Index: src/language/data-io/matrix-data.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/matrix-data.c,v
retrieving revision 1.20
diff -u -p -r1.20 matrix-data.c
--- src/language/data-io/matrix-data.c	5 Dec 2006 15:10:21 -0000	1.20
+++ src/language/data-io/matrix-data.c	10 Dec 2006 03:30:25 -0000
@@ -351,8 +351,7 @@ cmd_matrix_data (struct lexer *lexer, st
 
             for (i = 0; i < split_cnt; i++)
               {
-                struct mxd_var *mv = split[i]->aux;
-                assert (mv != NULL);
+                struct mxd_var *mv = var_get_aux (split[i]);
 		if (mv->var_type != MXD_CONTINUOUS)
 		  {
 		    msg (SE, _("Split variable %s is already another type."),
@@ -385,8 +384,7 @@ cmd_matrix_data (struct lexer *lexer, st
 	    for (i = 0; i < mx->n_factors; i++)
 	      {
                 struct variable *v = mx->factors[i];
-                struct mxd_var *mv = v->aux;
-                assert (mv != NULL);
+                struct mxd_var *mv = var_get_aux (v);
 		if (mv->var_type != MXD_CONTINUOUS)
 		  {
 		    msg (SE, _("Factor variable %s is already another type."),
@@ -606,7 +604,7 @@ cmd_matrix_data (struct lexer *lexer, st
     for (i = 0; i < dict_get_var_cnt (dataset_dict (ds)); i++)
       {
 	struct variable *v = dict_get_var (dataset_dict (ds), i);
-        struct mxd_var *mv = v->aux;
+        struct mxd_var *mv = var_get_aux (v);
 	int type = mv->var_type;
 	
 	assert (type >= 0 && type < MXD_COUNT);
@@ -699,8 +697,8 @@ compare_variables_by_mxd_var_type (const
 {
   struct variable *const *pa = a_;
   struct variable *const *pb = b_;
-  const struct mxd_var *a = (*pa)->aux;
-  const struct mxd_var *b = (*pb)->aux;
+  const struct mxd_var *a = var_get_aux (*pa);
+  const struct mxd_var *b = var_get_aux (*pb);
   
   if (a->var_type != b->var_type)
     return a->var_type > b->var_type ? 1 : -1;
@@ -715,7 +713,7 @@ attach_mxd_aux (struct variable *v, int 
 {
   struct mxd_var *mv;
   
-  assert (v->aux == NULL);
+  assert (var_get_aux (v) == NULL);
   mv = xmalloc (sizeof *mv);
   mv->var_type = var_type;
   mv->sub_type = sub_type;
@@ -1232,7 +1230,7 @@ nr_read_splits (struct nr_aux_data *nr, 
     {
       if (!compare) 
         {
-          struct mxd_var *mv = dict_get_split_vars (nr->dict)[0]->aux;
+          struct mxd_var *mv = var_get_aux (dict_get_split_vars (nr->dict)[0]);
           nr->split_values[0] = ++mv->sub_type; 
         }
       return true;
@@ -1331,11 +1329,11 @@ dump_cell_content (const struct dictiona
   int type = content_type[content];
 
   {
-    buf_copy_str_rpad (case_data_rw (c, mx->rowtype_->fv)->s, 8,
+    buf_copy_str_rpad (case_data_rw (c, mx->rowtype_)->s, 8,
                        content_names[content]);
     
     if (type != 1)
-      memset (case_data_rw (c, mx->varname_->fv)->s, ' ', 8);
+      memset (case_data_rw (c, mx->varname_)->s, ' ', 8);
   }
 
   {
@@ -1348,12 +1346,12 @@ dump_cell_content (const struct dictiona
 
 	for (j = 0; j < mx->n_continuous; j++)
 	  {
-            int fv = dict_get_var (dict, mx->first_continuous + j)->fv;
-            case_data_rw (c, fv)->f = *cp;
+            struct variable *v = dict_get_var (dict, mx->first_continuous + j);
+            case_data_rw (c, v)->f = *cp;
 	    cp++;
 	  }
 	if (type == 1)
-	  buf_copy_str_rpad (case_data_rw (c, mx->varname_->fv)->s, 8,
+	  buf_copy_str_rpad (case_data_rw (c, mx->varname_)->s, 8,
                              var_get_name (
                                dict_get_var (dict, mx->first_continuous + i)));
 	if (!write_case (wc_data))
@@ -1378,7 +1376,7 @@ nr_output_data (struct nr_aux_data *nr, 
     split_cnt = dict_get_split_cnt (nr->dict);
     split = dict_get_split_vars (nr->dict);
     for (i = 0; i < split_cnt; i++)
-      case_data_rw (c, split[i]->fv)->f = nr->split_values[i];
+      case_data_rw (c, split[i])->f = nr->split_values[i];
   }
 
   if (mx->n_factors)
@@ -1391,7 +1389,7 @@ nr_output_data (struct nr_aux_data *nr, 
 	    size_t factor;
 
 	    for (factor = 0; factor < mx->n_factors; factor++)
-              case_data_rw (c, mx->factors[factor]->fv)->f
+              case_data_rw (c, mx->factors[factor])->f
                 = nr->factor_values[factor + cell * mx->n_factors];
 	  }
 	  
@@ -1420,7 +1418,7 @@ nr_output_data (struct nr_aux_data *nr, 
       size_t factor;
 
       for (factor = 0; factor < mx->n_factors; factor++)
-	case_data_rw (c, mx->factors[factor]->fv)->f = SYSMIS;
+	case_data_rw (c, mx->factors[factor])->f = SYSMIS;
     }
     
     for (content = 0; content <= PROX; content++)
@@ -1631,7 +1629,7 @@ wr_output_data (struct wr_aux_data *wr,
     split_cnt = dict_get_split_cnt (wr->dict);
     split = dict_get_split_vars (wr->dict);
     for (i = 0; i < split_cnt; i++)
-      case_data_rw (c, split[i]->fv)->f = wr->split_values[i];
+      case_data_rw (c, split[i])->f = wr->split_values[i];
   }
 
   /* Sort the wr->data list. */
@@ -1665,8 +1663,7 @@ wr_output_data (struct wr_aux_data *wr,
 	  size_t factor;
 
 	  for (factor = 0; factor < mx->n_factors; factor++)
-            case_data_rw (c, mx->factors[factor]->fv)->f
-              = iter->factors[factor];
+            case_data_rw (c, mx->factors[factor])->f = iter->factors[factor];
 	}
 	
 	{
Index: src/language/data-io/print-space.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/print-space.c,v
retrieving revision 1.7
diff -u -p -r1.7 print-space.c
--- src/language/data-io/print-space.c	11 Nov 2006 23:10:00 -0000	1.7
+++ src/language/data-io/print-space.c	10 Dec 2006 03:30:28 -0000
@@ -23,6 +23,7 @@
 #include <stdlib.h>
 
 #include <data/procedure.h>
+#include <data/value.h>
 #include <language/command.h>
 #include <language/data-io/data-writer.h>
 #include <language/data-io/file-handle.h>
Index: src/language/data-io/print.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/data-io/print.c,v
retrieving revision 1.21
diff -u -p -r1.21 print.c
--- src/language/data-io/print.c	5 Dec 2006 15:10:21 -0000	1.21
+++ src/language/data-io/print.c	10 Dec 2006 03:30:28 -0000
@@ -460,7 +460,7 @@ print_trns_proc (void *trns_, struct cca
       ds_set_length (&trns->line, spec->first_column, ' ');
       if (spec->type == PRT_VAR)
         {
-          const union value *input = case_data (c, spec->var->fv);
+          const union value *input = case_data (c, spec->var);
           char *output = ds_put_uninit (&trns->line, spec->format.w);
           if (!spec->sysmis_as_spaces || input->f != SYSMIS)
             data_out (input, &spec->format, output);
Index: src/language/dictionary/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/ChangeLog,v
retrieving revision 1.6
diff -u -p -r1.6 ChangeLog
--- src/language/dictionary/ChangeLog	1 Dec 2006 06:06:52 -0000	1.6
+++ src/language/dictionary/ChangeLog	10 Dec 2006 03:30:28 -0000
@@ -1,3 +1,11 @@
+Sat Dec  9 18:44:26 2006  Ben Pfaff  <blp@gnu.org>
+
+	* variable-label.c: Move to src/data/variable.c.
+	
+	* vector.c (cmd_vector): Use PV_SAME_WIDTH in parse_variables
+	call, because string variables in a vector must have the same
+	width.
+
 Thu Nov 30 22:06:21 2006  Ben Pfaff  <blp@gnu.org>
 
 	* value-labels.c (get_label): Allow commas between values and
Index: src/language/dictionary/apply-dictionary.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/apply-dictionary.c,v
retrieving revision 1.11
diff -u -p -r1.11 apply-dictionary.c
--- src/language/dictionary/apply-dictionary.c	5 Dec 2006 15:10:21 -0000	1.11
+++ src/language/dictionary/apply-dictionary.c	10 Dec 2006 03:30:28 -0000
@@ -24,6 +24,7 @@
 #include <data/any-reader.h>
 #include <data/dictionary.h>
 #include <data/file-handle-def.h>
+#include <data/missing-values.h>
 #include <data/procedure.h>
 #include <data/value-labels.h>
 #include <data/variable.h>
@@ -86,32 +87,27 @@ cmd_apply_dictionary (struct lexer *lexe
             var_set_label (t, label);
         }
       
-      if (val_labs_count (s->val_labs) && var_is_long_string (t))
-	msg (SW, _("Cannot add value labels from source file to "
-		   "long string variable %s."),
-	     var_get_name (s));
-      else if (val_labs_count (s->val_labs))
-	{
-          if (val_labs_can_set_width (s->val_labs, var_get_width (t)))
+      if (var_has_value_labels (s))
+        {
+          if (!var_is_long_string (t))
             {
-              val_labs_destroy (t->val_labs);
-              t->val_labs = s->val_labs;
-              val_labs_set_width (t->val_labs, var_get_width (t));
-              s->val_labs = val_labs_create (var_get_width (s));
+              const struct val_labs *value_labels = var_get_value_labels (s);
+              if (val_labs_can_set_width (value_labels, var_get_width (t)))
+                var_set_value_labels (s, value_labels);
             }
-	}
-
+          else
+            msg (SW, _("Cannot add value labels from source file to "
+                       "long string variable %s."),
+                 var_get_name (s));
+        }
+      
       if (var_has_missing_values (s))
         {
           if (!var_is_long_string (t))
             {
-              struct missing_values miss;
-              mv_copy (&miss, var_get_missing_values (s));
-              if (mv_is_resizable (&miss, var_get_width (t))) 
-                {
-                  mv_resize (&miss, var_get_width (t));
-                  var_set_missing_values (t, &miss);
-                }
+              const struct missing_values *miss = var_get_missing_values (s);
+              if (mv_is_resizable (miss, var_get_width (t))) 
+                var_set_missing_values (t, miss);
             }
           else
             msg (SW, _("Cannot apply missing values from source file to "
Index: src/language/dictionary/formats.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/formats.c,v
retrieving revision 1.14
diff -u -p -r1.14 formats.c
--- src/language/dictionary/formats.c	5 Dec 2006 15:10:21 -0000	1.14
+++ src/language/dictionary/formats.c	10 Dec 2006 03:30:28 -0000
@@ -94,7 +94,7 @@ internal_cmd_formats (struct lexer *lexe
 	}
       if (!parse_format_specifier (lexer, &f)
           || !fmt_check_output (&f)
-          || !fmt_check_type_compat (&f, NUMERIC))
+          || !fmt_check_type_compat (&f, VAR_NUMERIC))
 	goto fail;
 
       if (!lex_match (lexer, ')'))
Index: src/language/dictionary/missing-values.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/missing-values.c,v
retrieving revision 1.13
diff -u -p -r1.13 missing-values.c
--- src/language/dictionary/missing-values.c	5 Dec 2006 15:10:21 -0000	1.13
+++ src/language/dictionary/missing-values.c	10 Dec 2006 03:30:28 -0000
@@ -22,7 +22,9 @@
 #include <stdlib.h>
 
 #include <data/data-in.h>
+#include <data/missing-values.h>
 #include <data/procedure.h>
+#include <data/value.h>
 #include <data/variable.h>
 #include <language/command.h>
 #include <language/lexer/lexer.h>
@@ -133,20 +135,15 @@ cmd_missing_values (struct lexer *lexer,
           
           for (i = 0; i < nv; i++) 
             {
-              if (!mv_is_resizable (&mv, var_get_width (v[i]))) 
+              if (mv_is_resizable (&mv, var_get_width (v[i]))) 
+                var_set_missing_values (v[i], &mv);
+              else 
                 {
                   msg (SE, _("Missing values provided are too long to assign "
                              "to variable of width %d."),
                        var_get_width (v[i]));
                   deferred_errors = true;
                 }
-              else 
-                {
-                  struct missing_values tmp;
-                  mv_copy (&tmp, &mv);
-                  mv_resize (&tmp, var_get_width (v[i]));
-                  var_set_missing_values (v[i], &tmp);
-                }
             }
         }
 
Index: src/language/dictionary/modify-variables.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/modify-variables.c,v
retrieving revision 1.13
diff -u -p -r1.13 modify-variables.c
--- src/language/dictionary/modify-variables.c	5 Dec 2006 15:10:21 -0000	1.13
+++ src/language/dictionary/modify-variables.c	10 Dec 2006 03:30:28 -0000
@@ -354,8 +354,12 @@ compare_variables_given_ordering (const 
   const struct ordering *ordering = ordering_;
 
   int result;
-  if (ordering->positional)
-    result = a->index < b->index ? -1 : a->index > b->index;
+  if (ordering->positional) 
+    {
+      size_t a_index = var_get_dict_index (a);
+      size_t b_index = var_get_dict_index (b);
+      result = a_index < b_index ? -1 : a_index > b_index; 
+    }
   else
     result = strcasecmp (var_get_name (a), var_get_name (b));
   if (!ordering->forward)
Index: src/language/dictionary/numeric.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/numeric.c,v
retrieving revision 1.17
diff -u -p -r1.17 numeric.c
--- src/language/dictionary/numeric.c	5 Dec 2006 15:10:21 -0000	1.17
+++ src/language/dictionary/numeric.c	10 Dec 2006 03:30:28 -0000
@@ -185,7 +185,7 @@ cmd_leave (struct lexer *lexer, struct d
   if (!parse_variables (lexer, dataset_dict (ds), &v, &nv, PV_NONE))
     return CMD_CASCADING_FAILURE;
   for (i = 0; i < nv; i++)
-    v[i]->leave = true;
+    var_set_leave (v[i], true);
   free (v);
 
   return lex_end_of_command (lexer);
Index: src/language/dictionary/split-file.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/split-file.c,v
retrieving revision 1.12
diff -u -p -r1.12 split-file.c
--- src/language/dictionary/split-file.c	5 Dec 2006 15:10:21 -0000	1.12
+++ src/language/dictionary/split-file.c	10 Dec 2006 03:30:28 -0000
@@ -96,12 +96,12 @@ output_split_file_values (const struct d
 
       tab_text (t, 0, i + 1, TAB_LEFT | TAT_PRINTF, "%s", var_get_name (v));
       
-      data_out (case_data (c, v->fv), print, temp_buf);
+      data_out (case_data (c, v), print, temp_buf);
       temp_buf[print->w] = 0;
 
       tab_text (t, 1, i + 1, TAT_PRINTF, "%.*s", print->w, temp_buf);
 
-      val_lab = val_labs_find (v->val_labs, *case_data (c, v->fv));
+      val_lab = var_lookup_value_label (v, case_data (c, v));
       if (val_lab)
 	tab_text (t, 2, i + 1, TAB_LEFT, val_lab);
     }
Index: src/language/dictionary/sys-file-info.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/sys-file-info.c,v
retrieving revision 1.17
diff -u -p -r1.17 sys-file-info.c
--- src/language/dictionary/sys-file-info.c	5 Dec 2006 15:10:21 -0000	1.17
+++ src/language/dictionary/sys-file-info.c	10 Dec 2006 03:30:28 -0000
@@ -24,10 +24,13 @@
 
 #include <data/dictionary.h>
 #include <data/file-handle-def.h>
+#include <data/format.h>
+#include <data/missing-values.h>
 #include <data/procedure.h>
 #include <data/sys-file-reader.h>
 #include <data/value-labels.h>
 #include <data/variable.h>
+#include <data/vector.h>
 #include <language/command.h>
 #include <language/data-io/file-handle.h>
 #include <language/lexer/lexer.h>
@@ -151,7 +154,7 @@ cmd_sysfile_info (struct lexer *lexer, s
   for (r = 1, i = 0; i < dict_get_var_cnt (d); i++)
     {
       struct variable *v = dict_get_var (d, i);
-      const int nvl = val_labs_count (v->val_labs);
+      const int nvl = val_labs_count (var_get_value_labels (v));
       
       if (r + 10 + nvl > nr)
 	{
@@ -275,7 +278,7 @@ cmd_display (struct lexer *lexer, struct
 	}
 
       if (sorted)
-	sort (vl, n, sizeof *vl, compare_var_ptr_names, NULL);
+	sort (vl, n, sizeof *vl, compare_var_ptrs_by_name, NULL);
 
       display_variables (vl, n, as);
 
@@ -399,7 +402,7 @@ display_variables (struct variable **vl,
 
       if (as == AS_DICTIONARY || as == AS_VARIABLES)
 	{
-	  int nvl = val_labs_count (v->val_labs);
+	  int nvl = val_labs_count (var_get_value_labels (v));
       
 	  if (r + 10 + nvl > nr)
 	    {
@@ -419,7 +422,8 @@ display_variables (struct variable **vl,
             }
 	  if (as != AS_NAMES)
 	    {
-	      tab_text (t, pc, r, TAT_PRINTF, "%d", v->index + 1);
+	      tab_text (t, pc, r, TAT_PRINTF, "%d",
+                        (int) var_get_dict_index (v) + 1);
 	      tab_hline (t, TAL_1, 0, nc - 1, r);
 	    }
 	  r++;
@@ -451,7 +455,7 @@ describe_variable (struct variable *v, s
 
   /* Put the name, var label, and position into the first row. */
   tab_text (t, 0, r, TAB_LEFT, var_get_name (v));
-  tab_text (t, 3, r, TAT_PRINTF, "%d", v->index + 1);
+  tab_text (t, 3, r, TAT_PRINTF, "%d", (int) var_get_dict_index (v) + 1);
 
   if (as == AS_DICTIONARY && var_has_label (v)) 
     {
@@ -524,8 +528,9 @@ describe_variable (struct variable *v, s
     }
 
   /* Value labels. */
-  if (as == AS_DICTIONARY && val_labs_count (v->val_labs))
+  if (as == AS_DICTIONARY && var_has_value_labels (v))
     {
+      const struct val_labs *val_labs = var_get_value_labels (v);
       struct val_labs_iterator *i;
       struct val_lab *vl;
       int orig_r = r;
@@ -537,8 +542,8 @@ describe_variable (struct variable *v, s
 #endif
 
       tab_hline (t, TAL_1, 1, 2, r);
-      for (vl = val_labs_first_sorted (v->val_labs, &i); vl != NULL;
-           vl = val_labs_next (v->val_labs, &i))
+      for (vl = val_labs_first_sorted (val_labs, &i); vl != NULL;
+           vl = val_labs_next (val_labs, &i))
         {
 	  char buf[128];
 
@@ -564,17 +569,6 @@ describe_variable (struct variable *v, s
   return r;
 }
 
-static int
-compare_vectors_by_name (const void *a_, const void *b_)
-{
-  struct vector *const *pa = a_;
-  struct vector *const *pb = b_;
-  struct vector *a = *pa;
-  struct vector *b = *pb;
-  
-  return strcasecmp (a->name, b->name);
-}
-
 /* Display a list of vectors.  If SORTED is nonzero then they are
    sorted alphabetically. */
 static void
@@ -596,7 +590,7 @@ display_vectors (const struct dictionary
   for (i = 0; i < nvec; i++)
     vl[i] = dict_get_vector (dict, i);
   if (sorted)
-    qsort (vl, nvec, sizeof *vl, compare_vectors_by_name);
+    qsort (vl, nvec, sizeof *vl, compare_vector_ptrs_by_name);
 
   t = tab_create (1, nvec + 1, 0);
   tab_headers (t, 0, 0, 1, 0);
@@ -606,7 +600,7 @@ display_vectors (const struct dictionary
   tab_text (t, 0, 0, TAT_TITLE | TAB_LEFT, _("Vector"));
   tab_flags (t, SOMF_NO_TITLE);
   for (i = 0; i < nvec; i++)
-    tab_text (t, 0, i + 1, TAB_LEFT, vl[i]->name);
+    tab_text (t, 0, i + 1, TAB_LEFT, vector_get_name (vl[i]));
   tab_submit (t);
 
   free (vl);
Index: src/language/dictionary/value-labels.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/value-labels.c,v
retrieving revision 1.13
diff -u -p -r1.13 value-labels.c
--- src/language/dictionary/value-labels.c	5 Dec 2006 15:10:21 -0000	1.13
+++ src/language/dictionary/value-labels.c	10 Dec 2006 03:30:28 -0000
@@ -136,7 +136,7 @@ erase_labels (struct variable **vars, si
 
   /* Erase old value labels if desired. */
   for (i = 0; i < var_cnt; i++)
-    val_labs_clear (vars[i]->val_labs);
+    var_clear_value_labels (vars[i]);
 }
 
 /* Parse all the labels for the VAR_CNT variables in VARS and add
@@ -188,7 +188,7 @@ get_label (struct lexer *lexer, struct v
 	}
 
       for (i = 0; i < var_cnt; i++)
-        val_labs_replace (vars[i]->val_labs, value, ds_cstr (&label));
+        var_replace_value_label (vars[i], &value, ds_cstr (&label));
 
       ds_destroy (&label);
 
Index: src/language/dictionary/variable-label.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/variable-label.c,v
retrieving revision 1.12
diff -u -p -r1.12 variable-label.c
--- src/language/dictionary/variable-label.c	5 Dec 2006 15:10:21 -0000	1.12
+++ src/language/dictionary/variable-label.c	10 Dec 2006 03:30:28 -0000
@@ -76,14 +76,3 @@ cmd_variable_labels (struct lexer *lexer
 
 
 
-const char *
-var_to_string(const struct variable *var)
-{
-  const char *label;
-  
-  if ( !var ) 
-    return 0;
-
-  label = var_get_label (var);
-  return label ? label : var_get_name (var);
-}
Index: src/language/dictionary/vector.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/dictionary/vector.c,v
retrieving revision 1.10
diff -u -p -r1.10 vector.c
--- src/language/dictionary/vector.c	11 Nov 2006 23:10:00 -0000	1.10
+++ src/language/dictionary/vector.c	10 Dec 2006 03:30:28 -0000
@@ -107,7 +107,7 @@ cmd_vector (struct lexer *lexer, struct 
 	    }
 
 	  if (!parse_variables (lexer, dict, &v, &nv,
-                                PV_SAME_TYPE | PV_DUPLICATE))
+                                PV_SAME_WIDTH | PV_DUPLICATE))
 	    goto fail;
 
           dict_create_vector (dict, vecnames, v, nv);
Index: src/language/expressions/evaluate.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/expressions/evaluate.c,v
retrieving revision 1.12
diff -u -p -r1.12 evaluate.c
--- src/language/expressions/evaluate.c	5 Dec 2006 15:10:21 -0000	1.12
+++ src/language/expressions/evaluate.c	10 Dec 2006 03:30:28 -0000
@@ -180,9 +180,9 @@ cmd_debug_evaluate (struct lexer *lexer,
             case_resize (c, old_value_cnt, dict_get_next_value_idx (d));
 
           if (lex_is_number (lexer))
-            case_data_rw (c, v->fv)->f = lex_tokval (lexer);
+            case_data_rw (c, v)->f = lex_tokval (lexer);
           else
-            memcpy (case_data_rw (c, v->fv)->s, ds_data (lex_tokstr (lexer)),
+            memcpy (case_data_rw (c, v)->s, ds_data (lex_tokstr (lexer)),
                     var_get_width (v));
           lex_get (lexer);
 
@@ -312,7 +312,7 @@ expr_debug_print_postfix (const struct e
           fprintf (stderr, "v<%s>", var_get_name (op->variable));
           break;
         case OP_vector:
-          fprintf (stderr, "vec<%s>", op->vector->name);
+          fprintf (stderr, "vec<%s>", vector_get_name (op->vector));
           break;
         case OP_integer:
           fprintf (stderr, "i<%d>", op->integer);
Index: src/language/expressions/helpers.h
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/expressions/helpers.h,v
retrieving revision 1.7
diff -u -p -r1.7 helpers.h
--- src/language/expressions/helpers.h	5 Nov 2006 05:20:53 -0000	1.7
+++ src/language/expressions/helpers.h	10 Dec 2006 03:30:28 -0000
@@ -19,6 +19,7 @@
 #include <data/settings.h>
 #include <data/value.h>
 #include <data/variable.h>
+#include <data/vector.h>
 #include <gsl-extras/gsl-extras.h>
 #include <language/expressions/public.h>
 #include <libpspp/compiler.h>
Index: src/language/expressions/operations.def
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/expressions/operations.def,v
retrieving revision 1.10
diff -u -p -r1.10 operations.def
--- src/language/expressions/operations.def	5 Dec 2006 15:10:21 -0000	1.10
+++ src/language/expressions/operations.def	10 Dec 2006 03:30:28 -0000
@@ -892,22 +892,22 @@ absorb_miss boolean function SYSMIS (x) 
 no_opt boolean function SYSMIS (num_var v)
      case c;
 {
-  return case_num (c, v->fv) == SYSMIS;
+  return case_num (c, v) == SYSMIS;
 }
 no_opt boolean function VALUE (num_var v)
      case c;
 {
-  return case_num (c, v->fv);
+  return case_num (c, v);
 }
 
 no_opt operator VEC_ELEM_NUM (idx)
      vector v;
      case c;
 {
-  if (idx >= 1 && idx <= v->cnt) 
+  if (idx >= 1 && idx <= vector_get_var_cnt (v)) 
     {
-      const struct variable *var = v->var[(int) idx - 1];
-      double value = case_num (c, var->fv);
+      const struct variable *var = vector_get_var (v, (size_t) idx - 1);
+      double value = case_num (c, var);
       return !var_is_num_user_missing (var, value) ? value : SYSMIS; 
     }
   else
@@ -915,11 +915,11 @@ no_opt operator VEC_ELEM_NUM (idx)
       if (idx == SYSMIS)
         msg (SE, _("SYSMIS is not a valid index value for vector "
                    "%s.  The result will be set to SYSMIS."),
-             v->name);
+             vector_get_name (v));
       else
         msg (SE, _("%g is not a valid index value for vector %s.  "
                    "The result will be set to SYSMIS."),
-             idx, v->name);
+             idx, vector_get_name (v));
       return SYSMIS;
     }
 }
@@ -929,21 +929,21 @@ absorb_miss no_opt string operator VEC_E
      vector v;
      case c;
 {
-  if (idx >= 1 && idx <= v->cnt)
+  if (idx >= 1 && idx <= vector_get_var_cnt (v))
     {
-      struct variable *var = v->var[(int) idx - 1];
-      return copy_string (e, case_str (c, var->fv), var_get_width (var));
+      struct variable *var = vector_get_var (v, (size_t) idx - 1);
+      return copy_string (e, case_str (c, var), var_get_width (var));
     }
   else
     {
       if (idx == SYSMIS)
         msg (SE, _("SYSMIS is not a valid index value for vector "
                    "%s.  The result will be set to the empty string."),
-             v->name);
+             vector_get_name (v));
       else
         msg (SE, _("%g is not a valid index value for vector %s.  "
                    "The result will be set to the empty string."),
-             idx, v->name);
+             idx, vector_get_name (v));
       return empty_string;
     }
 }
@@ -954,7 +954,7 @@ no_opt operator NUM_VAR ()
      case c;
      num_var v;
 {
-  double d = case_num (c, v->fv);
+  double d = case_num (c, v);
   return !var_is_num_user_missing (v, d) ? d : SYSMIS;
 }
 
@@ -964,7 +964,7 @@ no_opt string operator STR_VAR ()
      str_var v;
 {
   struct substring s = alloc_string (e, var_get_width (v));
-  memcpy (s.string, case_str (c, v->fv), var_get_width (v));
+  memcpy (s.string, case_str (c, v), var_get_width (v));
   return s;
 }
 
@@ -974,7 +974,7 @@ no_opt perm_only function LAG (num_var v
   struct ccase *c = lagged_case (ds, n_before);
   if (c != NULL)
     {
-      double x = case_num (c, v->fv);
+      double x = case_num (c, v);
       return !var_is_num_user_missing (v, x) ? x : SYSMIS;
     }
   else
@@ -987,7 +987,7 @@ no_opt perm_only function LAG (num_var v
   struct ccase *c = lagged_case (ds, 1);
   if (c != NULL)
     {
-      double x = case_num (c, v->fv);
+      double x = case_num (c, v);
       return !var_is_num_user_missing (v, x) ? x : SYSMIS;
     }
   else
@@ -1000,7 +1000,7 @@ no_opt perm_only string function LAG (st
 {
   struct ccase *c = lagged_case (ds, n_before);
   if (c != NULL)
-    return copy_string (e, case_str (c, v->fv), var_get_width (v));
+    return copy_string (e, case_str (c, v), var_get_width (v));
   else
     return empty_string;
 }
@@ -1011,7 +1011,7 @@ no_opt perm_only string function LAG (st
 {
   struct ccase *c = lagged_case (ds, 1);
   if (c != NULL)
-    return copy_string (e, case_str (c, v->fv), var_get_width (v));
+    return copy_string (e, case_str (c, v), var_get_width (v));
   else
     return empty_string;
 }
@@ -1020,14 +1020,14 @@ no_opt operator NUM_SYS ()
      case c;
      num_var v;
 {
-  return case_num (c, v->fv) == SYSMIS;
+  return case_num (c, v) == SYSMIS;
 }
 
 no_opt operator NUM_VAL ()
      case c;
      num_var v;
 {
-  return case_num (c, v->fv);
+  return case_num (c, v);
 }
 
 no_opt operator CASENUM ()
Index: src/language/expressions/parse.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/expressions/parse.c,v
retrieving revision 1.19
diff -u -p -r1.19 parse.c
--- src/language/expressions/parse.c	5 Dec 2006 15:10:21 -0000	1.19
+++ src/language/expressions/parse.c	10 Dec 2006 03:30:30 -0000
@@ -358,7 +358,7 @@ type_coercion_core (struct expression *e
       msg_disable ();
       if ((*node)->type == OP_format
           && fmt_check_input (&(*node)->format.f)
-          && fmt_check_type_compat (&(*node)->format.f, NUMERIC))
+          && fmt_check_type_compat (&(*node)->format.f, VAR_NUMERIC))
         {
           msg_enable ();
           if (do_coercion)
@@ -372,7 +372,7 @@ type_coercion_core (struct expression *e
       msg_disable ();
       if ((*node)->type == OP_format
           && fmt_check_output (&(*node)->format.f)
-          && fmt_check_type_compat (&(*node)->format.f, NUMERIC))
+          && fmt_check_type_compat (&(*node)->format.f, VAR_NUMERIC))
         {
           msg_enable ();
           if (do_coercion)
@@ -901,7 +901,7 @@ parse_vector_element (struct lexer *lexe
       || !lex_match (lexer, ')'))
     return NULL;
 
-  return expr_allocate_binary (e, (var_is_numeric (vector->var[0])
+  return expr_allocate_binary (e, (vector_get_type (vector) == VAR_NUMERIC
                                    ? OP_VEC_ELEM_NUM : OP_VEC_ELEM_STR),
                                element, expr_allocate_vector (e, vector));
 }
Index: src/language/lexer/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/language/lexer/ChangeLog,v
retrieving revision 1.19
diff -u -p -r1.19 ChangeLog
--- src/language/lexer/ChangeLog	3 Dec 2006 22:16:45 -0000	1.19
+++ src/language/lexer/ChangeLog	10 Dec 2006 03:30:30 -0000
@@ -1,3 +1,13 @@
+Sat Dec  9 18:46:11 2006  Ben Pfaff  <blp@gnu.org>
+
+	* variable-parser.h: New PV_SAME_WIDTH variable parsing option.
+
+	* variable-parser.c (add_variable): Implement new PV_SAME_WIDTH
+	option.
+	(parse_var_set_vars) Ditto.
+	(array_var_set_lookup_var_idx) Use new var_create, var_destroy
+	functions.
+
 Sat Dec  2 21:19:50 2006  Ben Pfaff  <blp@gnu.org>
 
 	General clean-up.
